unit timerunit;
{
  CPU clock microseconds timer
}

interface

uses windows;

var  CPUclock : double;    //CPU clock speed in MHz

procedure setCPUclock;     //must be called before any measurements
procedure getCPUticks(var count : Int64);

implementation

procedure getCPUticks(var count: Int64);
//store 64 bits CPU clock in variable count
begin
 asm
  mov ECX,count;
  RDTSC;          //lower 32 bits --> EAX, upper 32 bits ---> EDX
                  //RDTSC = DB $0F,$31
  mov [ECX],EAX;
  add ECX,4;
  mov [ECX],EDX;
 end;
end;

procedure setCPUclock;
//set variable CPUclock
//call this procedure before measuring any process time
var t1,t2 : cardinal;         //system clock ticks
    cput1,cput2 : Int64;      //CPU clock ticks
begin
 t1 := getTickCount;          //get milliseconds clock
 while getTickCount = t1 do;  //sync with update of 1 millisec interval
 getCPUticks(cput1);          //get CPU clock count
 t1 := gettickcount;          //get millisecs clock time
 repeat
  getCPUticks(cput2);         //get CPU clock count
  t2 := gettickcount;
 until t2-t1 >= 500;
 CPUclock := (cput2-cput1)/((t2-t1)*1e3);  //set CPU clock in microsecs
end;

end.
